<?php
namespace OCA\Dematpayslip\Db;

use JsonSerializable;

use OCP\AppFramework\Db\Entity;

class DematpayslipArchive extends Entity implements JsonSerializable {

    /**
     * Const status
     */
    const STATUS_DELETED       = -1;
    const STATUS_INITIALIZED   = 0;
    const STATUS_CREATED       = 1;
    const STATUS_TITLED        = 2;
    const STATUS_FILE_SENT     = 3;
    const STATUS_ORIENTATION   = 4;
    const STATUS_METADATA_SENT = 5;

    protected $idFile;
    protected $idUser;
    protected $filePath;
    protected $dematpayslipIdUser;
    protected $pastellIdDocument;
    protected $siret;
    protected $matricule;
    protected $year;
    protected $month;
    protected $lastname;
    protected $firstname;
    protected $startDate;
    protected $endDate;
    protected $editionDate;
    protected $status;
    protected $statusTime;
    protected $pastellUrl;
    protected $pastellLastAction;
    protected $importTime;
    protected $checksum;

    public function jsonSerialize() {
        return [
            'id'                 => $this->id,
            'idFile'             => $this->idFile,
            'idUser'             => $this->idUser,
            'filePath'           => $this->filePath,
            'dematpayslipIdUser' => $this->dematpayslipIdUser,
            'pastellIdDocument'  => $this->pastellIdDocument,
            'siret'              => $this->siret,
            'matricule'          => $this->matricule,
            'year'               => $this->year,
            'month'              => $this->month,
            'lastname'           => $this->lastname,
            'firstname'          => $this->firstname,
            'startDate'          => $this->startDate,
            'endDate'            => $this->endDate,
            'editionDate'        => $this->editionDate,
            'status'             => $this->status,
            'status_time'        => $this->statusTime,
            'pastellUrl'         => $this->pastellUrl,
            'pastellLastAction'  => $this->pastellLastAction,
            'importTime'         => $this->importTime,
            'checksum'           => $this->checksum,
        ];
    }

    /**
     * Determine if it have already been archived (can't modify)
     *
     * @return  bool
     */
    public function isArchived() {
        if (!empty($this->getPastellIdDocument())) {
            return true;
        } else {
            return false;
        }
    }
}
